<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2011 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_5/classes/prom_static.php $
 * $Id: prom_static.php 1848 2011-04-02 00:12:46Z Quietust $
 */

if (!defined('IN_GAME'))
	die("Access denied");

require_once(PROM_BASEDIR .'classes/prom_entity.php');

abstract class prom_static extends prom_entity
{
	// Static entities only need an ID - database fields and lock-related fields are irrelevant
	// Also, they should automatically load their data immediately
	public function __construct ($id)
	{
		parent::__construct($id, FALSE, 'DUAL', 'NULL', 0);
		$this->load();
	}

	// Static entities must reimplement this on their own
	public function load ()
	{
		warning('Static entity '. $this->id .' of type '. get_class($this) .' did not implement load()', 1);
		return FALSE;
	}

	// Static entities cannot be locked - throw a warning if something tries
	public function lock ($owner)
	{
		warning('Static entity '. $this->id .' of type '. get_class($this) .' attempted to lock', 1);
		return FALSE;
	}
	public function unlock ()
	{
		warning('Static entity '. $this->id .' of type '. get_class($this) .' attempted to unlock', 1);
		return FALSE;
	}
	public function save ($unlock = TRUE)
	{
		warning('Static entity '. $this->id .' of type '. get_class($this) .' attempted to save', 1);
		return FALSE;
	}
} // abstract class prom_static
?>
