<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2011 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_5/lang/en-US/guide/admin/locks.php $
 * $Id: locks.php 1848 2011-04-02 00:12:46Z Quietust $
 */

if (!defined('IN_GUIDE'))
	die('Access denied');

if ($adminflag & UFLAG_ADMIN)
	guidepage($topic, 'admin/locks', 'g_admin_locks', 'Database Locks');
function g_admin_locks ()
{
?>
<h2>Database Locks</h2>
<p>Due to the way database locking is implemented in this game, it is possible, albeit rare, for deadlocks to result. This page allows Administrators to cancel database locks in such an event.</p>
<p>Unlike other pages, this page can also be accessed if you are not logged in (since a database deadlock can prevent users from logging in), but will require entering the username and password of an Administrator account on every page load.</p>
<p>If there are any active database locks, they will be displayed in a series of tables, including the ID number of the user who has locked them. In place of the user ID, one of the following labels may be displayed instead:</p>
<dl>
    <dt><?=lang('ADMIN_LOCKS_NAME_NEW')?></dt>
        <dd>The entity was just created, usually from a new user signup or from an empire creating a new Clan.</dd>
    <dt><?=lang('ADMIN_LOCKS_NAME_TURNS')?></dt>
        <dd>The turns script is currently running.</dd>
    <dt><?=lang('ADMIN_LOCKS_NAME_RESET')?></dt>
        <dd>An Administrator is in the process of resetting the game to begin a new round.</dd>
    <dt><?=lang('ADMIN_LOCKS_NAME_HISTORY')?></dt>
        <dd>An Administrator is in the process of recording history for the current round.</dd>
    <dt><?=lang('ADMIN_LOCKS_NAME_SCRIPT')?></dt>
        <dd>A utility script is being run to perform some sort of maintenance on the game.</dd>
</dl>
<p>To unlock entities, simply check their corresponding checkboxes and click the "<?=lang('ADMIN_LOCKS_UNLOCK_SUBMIT')?>" button at the bottom of the page (specifying your username and password if you are not currently logged in); with luck, any other processes waiting on these locks should resolve themselves and unlock any remaining entities.</p>
<p>To quickly check (or uncheck) all entities of a particular type, click on the "<?=lang('ADMIN_LOCKS_COLUMN_TOGGLE')?>" link within the corresponding table.</p>
<?
}
?>
